
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Course_enrollmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const course_enrollments = await db.course_enrollments.create(
            {
                id: data.id || undefined,
        
        enrollment_role: data.enrollment_role
        ||
        null
            ,
            
        enrollment_status: data.enrollment_status
        ||
        null
            ,
            
        enrolled_at: data.enrolled_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await course_enrollments.setCourse( data.course || null, {
            transaction,
        });
        
        await course_enrollments.setUser( data.user || null, {
            transaction,
        });
        
        await course_enrollments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return course_enrollments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const course_enrollmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                enrollment_role: item.enrollment_role
            ||
            null
            ,
            
                enrollment_status: item.enrollment_status
            ||
            null
            ,
            
                enrolled_at: item.enrolled_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const course_enrollments = await db.course_enrollments.bulkCreate(course_enrollmentsData, { transaction });

        // For each item created, replace relation files
        

        return course_enrollments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const course_enrollments = await db.course_enrollments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.enrollment_role !== undefined) updatePayload.enrollment_role = data.enrollment_role;
        
        
        if (data.enrollment_status !== undefined) updatePayload.enrollment_status = data.enrollment_status;
        
        
        if (data.enrolled_at !== undefined) updatePayload.enrolled_at = data.enrolled_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await course_enrollments.update(updatePayload, {transaction});

        
        
        if (data.course !== undefined) {
            await course_enrollments.setCourse(
              
              data.course,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await course_enrollments.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await course_enrollments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return course_enrollments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const course_enrollments = await db.course_enrollments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of course_enrollments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of course_enrollments) {
                await record.destroy({transaction});
            }
        });


        return course_enrollments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const course_enrollments = await db.course_enrollments.findByPk(id, options);

        await course_enrollments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await course_enrollments.destroy({
            transaction
        });

        return course_enrollments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const course_enrollments = await db.course_enrollments.findOne(
            { where },
            { transaction },
        );

        if (!course_enrollments) {
            return course_enrollments;
        }

        const output = course_enrollments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.course = await course_enrollments.getCourse({
            transaction
        });
        
        
        output.user = await course_enrollments.getUser({
            transaction
        });
        
        
        output.organizations = await course_enrollments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.courses,
        as: 'course',
        
        where: filter.course ? {
          [Op.or]: [
            { id: { [Op.in]: filter.course.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.course.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.enrolled_atRange) {
                const [start, end] = filter.enrolled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    enrolled_at: {
                    ...where.enrolled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    enrolled_at: {
                    ...where.enrolled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.enrollment_role) {
                where = {
                    ...where,
                enrollment_role: filter.enrollment_role,
            };
            }
            
            if (filter.enrollment_status) {
                where = {
                    ...where,
                enrollment_status: filter.enrollment_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.course_enrollments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'course_enrollments',
                        'enrollment_role',
                        query,
                    ),
                ],
            };
        }

        const records = await db.course_enrollments.findAll({
            attributes: [ 'id', 'enrollment_role' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['enrollment_role', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.enrollment_role,
        }));
    }

    
};

